import * as ts from "typescript";
import { ApiItem } from "../abstractions/api-item";
import { ApiItemReferenceDictionary } from "../contracts/api-item-reference-dictionary";
import { TypeDto } from "../contracts/type-dto";
import { ApiCallableDto } from "../contracts/api-callable-dto";
/**
 * A callable api item base.
 */
export declare abstract class ApiCallableBase<TDeclaration extends ts.SignatureDeclaration, TExtractDto extends ApiCallableDto> extends ApiItem<TDeclaration, TExtractDto> {
    protected Parameters: ApiItemReferenceDictionary;
    protected TypeParameters: ApiItemReferenceDictionary;
    protected ReturnType: TypeDto | undefined;
    protected OnGatherData(): void;
}
