import * as ts from "typescript";
import { LogLevel } from "simplr-logger";
import { ApiItem, ApiItemOptions } from "./abstractions/api-item";
import { ApiItemReferenceDictionary } from "./contracts/api-item-reference-dictionary";
import { TypeDto } from "./contracts/type-dto";
import { AccessModifier } from "./contracts/access-modifier";
export declare namespace ApiHelpers {
    function VisitApiItem(declaration: ts.Declaration, symbol: ts.Symbol, options: ApiItemOptions): ApiItem | undefined;
    function ShouldVisit(declaration: ts.Declaration, options: ApiItemOptions): boolean;
    function GetItemsIdsFromSymbols(symbols: ts.UnderscoreEscapedMap<ts.Symbol> | undefined, options: ApiItemOptions): ApiItemReferenceDictionary;
    function GetItemsIdsFromDeclarations(declarations: ts.NodeArray<ts.Declaration>, options: ApiItemOptions): ApiItemReferenceDictionary;
    type HeritageKinds = ts.SyntaxKind.ImplementsKeyword | ts.SyntaxKind.ExtendsKeyword;
    function GetHeritageList(heritageClauses: ts.NodeArray<ts.HeritageClause>, kind: HeritageKinds, options: ApiItemOptions): TypeDto[];
    function TypeToApiTypeDto(type: ts.Type, options: ApiItemOptions): TypeDto;
    function ResolveAccessModifierFromModifiers(modifiers?: ts.NodeArray<ts.Modifier>): AccessModifier;
    function ModifierKindExistsInModifiers(modifiers: ts.NodeArray<ts.Modifier> | undefined, kind: ts.SyntaxKind): boolean;
    function LogWithDeclarationPosition(logLevel: LogLevel, declaration: ts.Declaration, message: string): void;
}
