import * as ts from "typescript";
export declare namespace TSHelpers {
    type DeclarationWithTypeNode = ts.Declaration & {
        type?: ts.TypeNode;
    };
    function GetTypeTextFromDeclaration(declaration: DeclarationWithTypeNode): string;
    function GetReturnTypeTextFromDeclaration(declaration: ts.SignatureDeclaration, typeChecker: ts.TypeChecker): string;
    /**
     * Returns the string part of `export * from "./module";`
     */
    function GetExportDeclarationImportString(declaration: ts.ExportDeclaration): string | undefined;
    /**
     * Returns `ts.SourceFile` from `ts.ExportDeclaration`.
     */
    function GetSourceFileFromExport(declaration: ts.ExportDeclaration, program: ts.Program): ts.SourceFile | undefined;
    /**
     * Returns Symbol from declaration.
     */
    function GetSymbolFromDeclaration(declaration: ts.Declaration, typeChecker: ts.TypeChecker): ts.Symbol | undefined;
    type TypeWithTypeArguments = ts.Type & {
        typeArguments: ts.Type[];
    };
    function IsTypeWithTypeArguments(type: ts.Type): type is TypeWithTypeArguments;
    function IsTypeUnionOrIntersectionType(type: ts.Type): type is ts.UnionOrIntersectionType;
    function IsTypeUnionType(type: ts.Type): type is ts.UnionType;
    function IsTypeIntersectionType(type: ts.Type): type is ts.IntersectionType;
    function GetResolvedModule(sourceFile: ts.SourceFile, moduleNameText: string): ts.ResolvedModuleFull | undefined;
    /**
     * Source: @microsoft/api-extractor (MIT)
     * Github: https://goo.gl/tLoJUe
     */
    function FollowSymbolAliases(symbol: ts.Symbol, typeChecker: ts.TypeChecker): ts.Symbol;
}
